//+------------------------------------------------------------------+
//|                                                        Trade manager .mq4 |
//|                                                          Michael |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Michael"
#property link      "https://www.mql5.com"
#property version   "1.00"
#property strict
#property description "EA Trade Manager for Friday evening." 

#property description ""
//--- display window of the input parameters during the script's launch 

extern bool       ShowComment    =true;
extern double     Lot            =0.01;
extern int        SL             = 20;
extern int        TP             = 1;
extern int        magicnumber    = 111;
extern bool       WriteScreenshots=true;
extern string     EntryDay       = "Friday";
extern datetime   EntryHour      = 22;
extern double BuyStop_pip = 5;
extern double SellStop_pip = 50;

//for button(s)
bool   EnableTrade=true;  //enable/disable Button
int    TradeButtonLoc   = 0;
string TradeObjName     = "Trade Button0";
string BtnName          = "BuyStop";
//
bool   EnableTrade1=true;  //enable/disable Button
int    TradeButtonLoc1   = 25;
string TradeObjName1     = "Trade Button1";
string BtnName1          = "SellStop";
//
bool   EnableTrade2=true;  //enable/disable Button
int    TradeButtonLoc2   = 50;
string TradeObjName2     = "Trade Button2";
string BtnName2          = "All";
//
bool   EnableTrade3=true;  //enable/disable Button
int    TradeButtonLoc3   = 75;
string TradeObjName3     = "Trade Button3";
string BtnName3          = "Open buy";

bool   EnableTrade4=true;  //enable/disable Button
int    TradeButtonLoc4   = 100;
string TradeObjName4     = "Trade Button4";
string BtnName4          = "Open sell";

bool   EnableTrade5=true;  //enable/disable Button
int    TradeButtonLoc5   = 125;
string TradeObjName5     = "Trade Button5";
string BtnName5          = "BuyStop";

bool   EnableTrade6=true;  //enable/disable Button
int    TradeButtonLoc6   = 150;
string TradeObjName6     = "Trade Button6";
string BtnName6          = "SellStop";
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---

   TradingButton();
   TradingButton1();
   TradingButton2();
   TradingButton3();
   TradingButton4();
   TradingButton5();
   TradingButton6();
//---

//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| ChartEvent function
//+------------------------------------------------------------------+
void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
  {
   if(sparam==TradeObjName) TradeButtonClick();
   if(sparam==TradeObjName1) TradeButtonClick1();
   if(sparam==TradeObjName2) TradeButtonClick2();
   if(sparam==TradeObjName3) TradeButtonClick3();
   if(sparam==TradeObjName4) TradeButtonClick4(); //if tradeObjName3, then button3 will sell (instead of buy) :D
   if(sparam==TradeObjName5) TradeButtonClick5();
   if(sparam==TradeObjName6) TradeButtonClick6();
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
   for(int cnt=0; cnt<=2; cnt++)
      ObjectDelete(ChartID(),"Trade Button"+(string)cnt);

//---
   Print("Bye.");
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()

  {

   double point;
   int    digits;
   string msg="Trade Manager EA  \n";

   for(int i=0; i<OrdersTotal(); i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
        {
         if((OrderSymbol()==Symbol()))
           {
            digits= MarketInfo(OrderSymbol(),MODE_DIGITS);
            point = MarketInfo(OrderSymbol(),MODE_POINT);
            msg=msg+"All open orders"+OrderSymbol()+"  Open Price: "+DoubleToStr(OrderOpenPrice(),digits)+"  SL = "+DoubleToStr(OrderStopLoss(),digits)+" ("+")\n";
           }
        }
     }

   if(ShowComment) Comment(msg);

  }
//+------------------------------------------------------------------+
//| Create buttons + functions                                                                 |
//+------------------------------------------------------------------+

void TradeButtonClick()
  {
   ObjectSetInteger(0,TradeObjName,OBJPROP_STATE,false);
   ObjectSet(TradeObjName,OBJPROP_YDISTANCE,-30); //set distance property
   CloseAllBuyStop();
   ObjectSet(TradeObjName,OBJPROP_YDISTANCE,TradeButtonLoc); //set distance property
   ObjectSetInteger(0,TradeObjName,OBJPROP_STATE,true);
  }
//+------------------------------------------------------------------+
//| Expert TradingButton function
//+------------------------------------------------------------------+
void TradingButton()
  {
   long   current_chart_id=ChartID();

   ObjectCreate(current_chart_id,TradeObjName,OBJ_BUTTON,0,0,0); //creating label object (it does not have time/price coordinates)
   ObjectSetInteger(current_chart_id,TradeObjName,OBJPROP_COLOR,clrRed); //set color to Red
   ObjectSetString(current_chart_id,TradeObjName,OBJPROP_TEXT,BtnName); //set text property
   ObjectSet(TradeObjName,OBJPROP_YDISTANCE,TradeButtonLoc); //set distance property
   ObjectSetInteger(current_chart_id,TradeObjName,OBJPROP_COLOR,clrBlue); //set color to Blue
  }
//+------------------------------------------------------------------+
//| TradeButtonClick function
//+------------------------------------------------------------------+
void TradeButtonClick1()
  {
   ObjectSetInteger(0,TradeObjName1,OBJPROP_STATE,false);
   ObjectSet(TradeObjName1,OBJPROP_YDISTANCE,-30); //set distance property
   CloseAllSellStop();
   ObjectSet(TradeObjName1,OBJPROP_YDISTANCE,TradeButtonLoc1); //set distance property
   ObjectSetInteger(0,TradeObjName1,OBJPROP_STATE,true);
  }
//+------------------------------------------------------------------+
//| Expert TradingButton function
//+------------------------------------------------------------------+
void TradingButton1()
  {
   long   current_chart_id=ChartID();

   ObjectCreate(current_chart_id,TradeObjName1,OBJ_BUTTON,0,0,0); //creating label object (it does not have time/price coordinates)
   ObjectSetInteger(current_chart_id,TradeObjName1,OBJPROP_COLOR,clrRed); //set color to Red
   ObjectSetString(current_chart_id,TradeObjName1,OBJPROP_TEXT,BtnName1); //set text property
   ObjectSet(TradeObjName1,OBJPROP_YDISTANCE,TradeButtonLoc1); //set distance property
   ObjectSetInteger(current_chart_id,TradeObjName1,OBJPROP_COLOR,clrBlue); //set color to Blue
  }
//+------------------------------------------------------------------+
//| TradeButtonClick function
//+------------------------------------------------------------------+
void TradeButtonClick2()
  {
   ObjectSetInteger(0,TradeObjName2,OBJPROP_STATE,false);
   ObjectSet(TradeObjName2,OBJPROP_YDISTANCE,-30); //set distance property
   CloseAll();
   ObjectSet(TradeObjName2,OBJPROP_YDISTANCE,TradeButtonLoc2); //set distance property
   ObjectSetInteger(0,TradeObjName2,OBJPROP_STATE,true);
  }
//+------------------------------------------------------------------+
//| Expert TradingButton function
//+------------------------------------------------------------------+
void TradingButton2()
  {
   long   current_chart_id=ChartID();

   ObjectCreate(current_chart_id,TradeObjName2,OBJ_BUTTON,0,0,0); //creating label object (it does not have time/price coordinates)
   ObjectSetInteger(current_chart_id,TradeObjName2,OBJPROP_COLOR,clrRed); //set color to Red
   ObjectSetString(current_chart_id,TradeObjName2,OBJPROP_TEXT,BtnName2); //set text property
   ObjectSet(TradeObjName2,OBJPROP_YDISTANCE,TradeButtonLoc2); //set distance property
   ObjectSetInteger(current_chart_id,TradeObjName2,OBJPROP_COLOR,clrBlue); //set color to Blue
  }
//+------------------------------------------------------------------+
//| TradeButtonClick function
//+------------------------------------------------------------------+
void TradeButtonClick3()
  {
   ObjectSetInteger(0,TradeObjName3,OBJPROP_STATE,false);
   ObjectSet(TradeObjName3,OBJPROP_YDISTANCE,-30); //set distance property
   OpenBuy();
   ObjectSet(TradeObjName3,OBJPROP_YDISTANCE,TradeButtonLoc3); //set distance property
   ObjectSetInteger(0,TradeObjName3,OBJPROP_STATE,true);
  }
//+------------------------------------------------------------------+
//| Expert TradingButton function
//+------------------------------------------------------------------+
void TradingButton3()
  {
   long   current_chart_id=ChartID();

   ObjectCreate(current_chart_id,TradeObjName3,OBJ_BUTTON,0,0,0); //creating label object (it does not have time/price coordinates)
   ObjectSetInteger(current_chart_id,TradeObjName3,OBJPROP_COLOR,clrRed); //set color to Red
   ObjectSetString(current_chart_id,TradeObjName3,OBJPROP_TEXT,BtnName3); //set text property
   ObjectSet(TradeObjName3,OBJPROP_YDISTANCE,TradeButtonLoc3); //set distance property
   ObjectSetInteger(current_chart_id,TradeObjName3,OBJPROP_COLOR,clrBlue); //set color to Blue
  }
//+------------------------------------------------------------------+
//| TradeButtonClick function
//+------------------------------------------------------------------+
void TradeButtonClick4()
  {
   ObjectSetInteger(0,TradeObjName4,OBJPROP_STATE,false);
   ObjectSet(TradeObjName4,OBJPROP_YDISTANCE,-30); //set distance property
   OpenSell();
   ObjectSet(TradeObjName4,OBJPROP_YDISTANCE,TradeButtonLoc4); //set distance property
   ObjectSetInteger(0,TradeObjName4,OBJPROP_STATE,true);
  }
//+------------------------------------------------------------------+
//| Expert TradingButton function
//+------------------------------------------------------------------+
void TradingButton4()
  {
   long   current_chart_id=ChartID();

   ObjectCreate(current_chart_id,TradeObjName4,OBJ_BUTTON,0,0,0); //creating label object (it does not have time/price coordinates)
   ObjectSetInteger(current_chart_id,TradeObjName4,OBJPROP_COLOR,clrRed); //set color to Red
   ObjectSetString(current_chart_id,TradeObjName4,OBJPROP_TEXT,BtnName4); //set text property
   ObjectSet(TradeObjName4,OBJPROP_YDISTANCE,TradeButtonLoc4); //set distance property
   ObjectSetInteger(current_chart_id,TradeObjName4,OBJPROP_COLOR,clrBlue); //set color to Blue
  }



//+------------------------------------------------------------------+
//| TradeButtonClick function
//+------------------------------------------------------------------+
void TradeButtonClick5()
  {
   ObjectSetInteger(0,TradeObjName5,OBJPROP_STATE,false);
   ObjectSet(TradeObjName5,OBJPROP_YDISTANCE,-30); //set distance property
   OpenBuyStop();
   ObjectSet(TradeObjName5,OBJPROP_YDISTANCE,TradeButtonLoc5); //set distance property
   ObjectSetInteger(0,TradeObjName5,OBJPROP_STATE,true);
  }
//+------------------------------------------------------------------+
//| Expert TradingButton function
//+------------------------------------------------------------------+
void TradingButton5()
  {
   long   current_chart_id=ChartID();

   ObjectCreate(current_chart_id,TradeObjName5,OBJ_BUTTON,0,0,0); //creating label object (it does not have time/price coordinates)
   ObjectSetInteger(current_chart_id,TradeObjName5,OBJPROP_COLOR,clrRed); //set color to Red
   ObjectSetString(current_chart_id,TradeObjName5,OBJPROP_TEXT,BtnName5); //set text property
   ObjectSet(TradeObjName5,OBJPROP_YDISTANCE,TradeButtonLoc5); //set distance property
   ObjectSetInteger(current_chart_id,TradeObjName5,OBJPROP_COLOR,clrBlue); //set color to Blue
  }



//+------------------------------------------------------------------+
//| TradeButtonClick function
//+------------------------------------------------------------------+
void TradeButtonClick6()
  {
   ObjectSetInteger(0,TradeObjName6,OBJPROP_STATE,false);
   ObjectSet(TradeObjName6,OBJPROP_YDISTANCE,-30); //set distance property
   OpenSell();
   ObjectSet(TradeObjName6,OBJPROP_YDISTANCE,TradeButtonLoc6); //set distance property
   ObjectSetInteger(0,TradeObjName6,OBJPROP_STATE,true);
  }
//+------------------------------------------------------------------+
//| Expert TradingButton function
//+------------------------------------------------------------------+
void TradingButton6()
  {
   long   current_chart_id=ChartID();

   ObjectCreate(current_chart_id,TradeObjName6,OBJ_BUTTON,0,0,0); //creating label object (it does not have time/price coordinates)
   ObjectSetInteger(current_chart_id,TradeObjName6,OBJPROP_COLOR,clrRed); //set color to Red
   ObjectSetString(current_chart_id,TradeObjName6,OBJPROP_TEXT,BtnName6); //set text property
   ObjectSet(TradeObjName6,OBJPROP_YDISTANCE,TradeButtonLoc6); //set distance property
   ObjectSetInteger(current_chart_id,TradeObjName6,OBJPROP_COLOR,clrBlue); //set color to Blue
  }


















//+------------------------------------------------------------------+
//| CLOSE ALL OPENED POSITIONS
//+------------------------------------------------------------------+
void CloseAllBuyStop()
  {
   int total= OrdersTotal();
   for(int i=total-1; i>=0; i--)
     {
      int  ticket=OrderSelect(i,SELECT_BY_POS);
      if(OrderType()==OP_BUYSTOP)
        {
         //Delete opened buystop orders
         bool result=OrderDelete(OrderTicket(),clrNONE);
         if(result==false)
           {
            Print("Order ",OrderTicket()," failed to close. Error: ",GetLastError());
            Sleep(300);
           }
        }
     }
  }
//+------------------------------------------------------------------+
//| CLOSE ALL OPENED POSITIONS
//+------------------------------------------------------------------+
void CloseAllSellStop()
  {
   int total= OrdersTotal();
   for(int i=total-1; i>=0; i--)
     {
      int  ticket=OrderSelect(i,SELECT_BY_POS);
      if(OrderType()==OP_SELLSTOP)
        {
         //Delete opened buystop orders
         bool result=OrderDelete(OrderTicket(),clrNONE);
         if(result==false)
           {
            Print("Order ",OrderTicket()," failed to close. Error: ",GetLastError());
            Sleep(300);
           }
        }
     }
  }
//+------------------------------------------------------------------+
//| CLOSE ALL OPENED POSITIONS
//+------------------------------------------------------------------+
void CloseAll()
  {
   int total= OrdersTotal();
   for(int i=total-1; i>=0; i--)
     {
      int  ticket = OrderSelect(i,SELECT_BY_POS);
      int  type   = OrderType();
      bool result = false;

      switch(type)
        {
         //Delete opened buystop orders
         case OP_BUYSTOP  : result=OrderDelete(OrderTicket(),clrNONE);
         break;

         //Delete opened buylimit orders
         case OP_BUYLIMIT  : result=OrderDelete(OrderTicket(),clrNONE);
         break;

         //Close opened long positions
         case OP_BUY  : result=OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_BID),5,clrNONE);

         //Close opened short positions
         case OP_SELL : result=OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_ASK),5,clrNONE);
         break;

         //Delete opened sellstop orders
         case OP_SELLSTOP : result=OrderDelete(OrderTicket(),clrNONE);
         break;

         //Delete opened selllimit orders
         case OP_SELLLIMIT : result=OrderDelete(OrderTicket(),clrNONE);
        }

      if(result==false)
        {
         Print("Order ",OrderTicket()," failed to close. Error: ",GetLastError());
         Sleep(100);
        }
     }
  }
//+------------------------------------------------------------------+
//|          open buy order                                                        |
//+------------------------------------------------------------------+
void OpenBuy()
  {
   int total=OrdersTotal();
   double SLB = Ask-(SL*Point*10);
   double TPB = Ask+(TP*Point*10);
   int Ticket = -1;
   for(int x=0; x<1; x++)
     {
      Ticket=-1; // set the variable to -1... no trade
      for(int i=0; i<1 && Ticket==-1; i++)
        {
         RefreshRates();
         Ticket=OrderSend(Symbol(),OP_BUY,Lot,Ask,3,SLB,TPB,"Open Order",magicnumber,0,Green);
         // OrderSend(Symbol(),OP_SELL,lot,Ask,3,TPB+(Ext1*Point),SLB-(Ext2*Point),"Doubler SELL",magicnumber,0,Green);
         if(Ticket!=-1)

           {
            break; // get out of the loop in case of success
            Print("Order ",OrderTicket()," success to open. Error: ",GetLastError());
            Sleep(3000);

           }
         else
         //Alert("SL*Point",SL*Point,"Bid-(SL*Point)",Bid-(SL*Point),"   buy fail ","  slb ",SLB," tpb ",TPB,"  sl",SL,"  tp",TP," bid  ",Bid," ask  ",Ask," point ",Point,"  error: ",GetLastError());
            Alert("Buy order failed. Error: ",GetLastError());
         break;
        }

     }

  }
//+------------------------------------------------------------------+
//|           open sell order                                                       |
//+------------------------------------------------------------------+
void OpenSell()
  {
   int total=OrdersTotal();
   double SLB = Bid+(SL*Point*10);
   double TPB = Bid-(TP*Point*10);
   int Ticket = -1;
   for(int x=0; x<1; x++)
     {
      Ticket=-1; // set the variable to -1... no trade
      for(int i=0; i<1 && Ticket==-1; i++)
        {
         RefreshRates();
         Ticket=OrderSend(Symbol(),OP_SELL,Lot,Bid,3,SLB,TPB,"Open Order",magicnumber,0,Green);
         // OrderSend(Symbol(),OP_SELL,lot,Ask,3,TPB+(Ext1*Point),SLB-(Ext2*Point),"Doubler SELL",magicnumber,0,Green);
         if(Ticket!=-1)

           {
            break; // get out of the loop in case of success
            Print("Order ",OrderTicket()," success to open. Error: ",GetLastError());
            Sleep(3000);

           }
         else
         //Alert("SL*Point",SL*Point,"Bid-(SL*Point)",Bid-(SL*Point),"   buy fail ","  slb ",SLB," tpb ",TPB,"  sl",SL,"  tp",TP," bid  ",Bid," ask  ",Ask," point ",Point,"  error: ",GetLastError());
            Alert("Sell order failed. Error: ",GetLastError());
        }

     }

  }


//+------------------------------------------------------------------+
//|           open sell order                                                       |
//+------------------------------------------------------------------+
void OpenBuyStop()
  {
   int total=OrdersTotal();
   double SLB = Bid-(SL*Point*10);
   double TPB = Bid+(TP*Point*10);
   double BuyStop = BuyStop_pip * Point *10;
   int Ticket = -1;
   for(int x=0; x<1; x++)
     {
      Ticket=-1; // set the variable to -1... no trade
      for(int i=0; i<1 && Ticket==-1; i++)
        {
         RefreshRates();
         Ticket=OrderSend(Symbol(),OP_BUYSTOP,Lot,Ask+BuyStop,3,SLB,TPB,"Open Order",magicnumber,0,Green);
         // OrderSend(Symbol(),OP_SELL,lot,Ask,3,TPB+(Ext1*Point),SLB-(Ext2*Point),"Doubler SELL",magicnumber,0,Green);
         if(Ticket!=-1)

           {
            break; // get out of the loop in case of success
            Print("Order ",OrderTicket()," success to open. Error: ",GetLastError());
            Sleep(3000);

           }
         else
         //Alert("SL*Point",SL*Point,"Bid-(SL*Point)",Bid-(SL*Point),"   buy fail ","  slb ",SLB," tpb ",TPB,"  sl",SL,"  tp",TP," bid  ",Bid," ask  ",Ask," point ",Point,"  error: ",GetLastError());
            Alert("Buy stop order failed. Error: ",GetLastError());
        }

     }

  }

void OpenSellStop()
  {
   int total=OrdersTotal();
   double SLB = Bid+(SL*Point*10);
   double TPB = Bid-(TP*Point*10);
   double SellStop = SellStop_pip * Point *10;
   int Ticket = -1;
   for(int x=0; x<1; x++)
     {
      Ticket=-1; // set the variable to -1... no trade
      for(int i=0; i<1 && Ticket==-1; i++)
        {
         RefreshRates();
         Ticket=OrderSend(Symbol(),OP_SELLSTOP,Lot,Bid-SellStop,3,SLB,TPB,"Open Order",magicnumber,0,Green);
         // OrderSend(Symbol(),OP_SELL,lot,Ask,3,TPB+(Ext1*Point),SLB-(Ext2*Point),"Doubler SELL",magicnumber,0,Green);
         if(Ticket!=-1)

           {
            break; // get out of the loop in case of success
            Print("Order ",OrderTicket()," success to open. Error: ",GetLastError());
            Sleep(3000);

           }
         else
         //Alert("SL*Point",SL*Point,"Bid-(SL*Point)",Bid-(SL*Point),"   buy fail ","  slb ",SLB," tpb ",TPB,"  sl",SL,"  tp",TP," bid  ",Bid," ask  ",Ask," point ",Point,"  error: ",GetLastError());
            Alert("Sell stop order failed. Error: ",GetLastError());
        }

     }

  }


/*  void Screenshot(string moment_name)
{
    if ( WriteScreenshots )
        WindowScreenShot(WindowExpertName()+"_"+Symbol()+"_M"+Period()+"_"+
                         Year()+"-"+two_digits(Month())+"-"+two_digits(Day())+"_"+
                         two_digits(Hour())+"-"+two_digits(Minute())+"-"+two_digits(Seconds())+"_"+
                         moment_name+".gif", 1024, 768);
}
  
  */







//+------------------------------------------------------------------+
//| ? questions?                                                                 |
//+------------------------------------------------------------------+
/*
  1. how can I set another distance (x and y) for the buttons
  answer: int    TradeButtonLoc2   = 50; for vertical. but how horizontal?
  2. 
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  */
//+------------------------------------------------------------------+
